;criao de vos de porta em desenho de planta para a escala 1/100
; necessrio que previamente haja uma planta
;com uma informao em "region" a identificar a parede
;a variavel delobj deve estar com o valor 1
;2020

(defun c:vporta ()
;parametros gerais
	(setq pontos (getvar "osmode"))
	(setq pontos3d (getvar "3dosmode"))
	(setq geom (getvar "delobj"))
	(setvar "delobj" 1)	
;desenho simblico da porta para a escala 1/100
	(desenho_porta)
	
;identificao da parede
	(setq existencia (entsel "\nEscolha a parede: "))

;execuo automatica da rotina
	(setvar "osmode" 0)	
	(command "rectang" 
						(polar p2t (angle p4t p1t) 0.5)
						(polar p4t (angle p1t p4t) 0.5)
						)
	(setq vao (entlast))			
	(command "region" (entlast) "")
	(setq ent1 (entlast))
	(command "subtract" existencia "" ent1 "")
	
;reposio de parametros
	(setvar "delobj" geom)
	(setvar "osmode" pontos)
	(setvar "3dosmode" pontos3d)
	(command "ucs" "world")
) ;encerrar funo principal


(defun desenho_porta () 
	(setq ponto (getvar "osmode"))
	(setvar "osmode" 32)
	(setq p1 (getpoint "\nIndique o ponto onde a porta gira:  "))
	(setq p2 (getpoint "\nIndique o ponto onde a porta bate: "))
	(setq p3 (getpoint "\nIndique para que lado a porta abre, indicando um ponto: "))
	(setq p4 (getpoint "\nIndique um ponto para informar da espessura da parede com referncia ao ponto da charneira:  "))
	(setvar "osmode" 0)
	(command "ucs" "n" "3" p1 p2 p3) 
	(setq p1t (trans p1 0 1) p2t (trans p2 0 1) p4t (trans p4 0 1))
	(command "arc" "c" p1t p2t "a" "90")
	(command "line" p1t (list (car p1t) (+ (cadr p1t) (distance p1t p2t))) "")
) 

